package org.openfdl.text;
// $ANTLR : "OpenFDL.g" -> "FDLParser.java"$

/*
 * OpenFDL Compiler
 * Copyright (C) 2005 Matt Acosta
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

/**
 * FDLParser.java
 * 
 * @author Matt Acosta
 * @version 1.00
 */

public class FDLParser extends antlr.LLkParser       implements FDLTreeParserTokenTypes
 {

	private boolean parseFail = false;

protected FDLParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public FDLParser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected FDLParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public FDLParser(TokenStream lexer) {
  this(lexer,1);
}

public FDLParser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

	public final void parse() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST parse_AST = null;
		
		try {      // for error handling
			{
			_loop752:
			do {
				if (((LA(1) >= LITERAL_var && LA(1) <= LITERAL_appfunc))) {
					fdlLine();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop752;
				}
				
			} while (true);
			}
			
				if (parseFail)
					reportWarning("parser failure before EOF");
			
			parse_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_0);
		}
		returnAST = parse_AST;
	}
	
	public final void fdlLine() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST fdlLine_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_var:
			case LITERAL_appvar:
			{
				varDecl();
				astFactory.addASTChild(currentAST, returnAST);
				fdlLine_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_func:
			{
				funcDecl();
				astFactory.addASTChild(currentAST, returnAST);
				fdlLine_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_appfunc:
			{
				appFuncDecl();
				astFactory.addASTChild(currentAST, returnAST);
				fdlLine_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_1);
		}
		returnAST = fdlLine_AST;
	}
	
	public final void varDecl() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST varDecl_AST = null;
		
		try {      // for error handling
			varType();
			astFactory.addASTChild(currentAST, returnAST);
			{
			switch ( LA(1)) {
			case INTLIT:
			{
				AST tmp1_AST = null;
				tmp1_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp1_AST);
				match(INTLIT);
				break;
			}
			case IDENT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp2_AST = null;
			tmp2_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp2_AST);
			match(IDENT);
			AST tmp3_AST = null;
			tmp3_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp3_AST);
			match(COLON);
			typeSpec();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp4_AST = null;
			tmp4_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp4_AST);
			match(SEMI);
			varDecl_AST = (AST)currentAST.root;
		}
		catch (RecognitionException e) {
			
				parseFail = true;
				reportError("line " + e.getLine() + ":" + e.getColumn() +
					", " + e.getMessage());
			
		}
		returnAST = varDecl_AST;
	}
	
	public final void funcDecl() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST funcDecl_AST = null;
		
		try {      // for error handling
			funcType();
			astFactory.addASTChild(currentAST, returnAST);
			{
			switch ( LA(1)) {
			case INTLIT:
			{
				AST tmp5_AST = null;
				tmp5_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp5_AST);
				match(INTLIT);
				break;
			}
			case IDENT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp6_AST = null;
			tmp6_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp6_AST);
			match(IDENT);
			funcParameters();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp7_AST = null;
			tmp7_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp7_AST);
			match(COLON);
			typeSpec();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp8_AST = null;
			tmp8_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp8_AST);
			match(SEMI);
			funcDecl_AST = (AST)currentAST.root;
		}
		catch (RecognitionException e) {
			
				parseFail = true;
				reportError("line " + e.getLine() + ":" + e.getColumn() +
					", " + e.getMessage());
			
		}
		returnAST = funcDecl_AST;
	}
	
	public final void appFuncDecl() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST appFuncDecl_AST = null;
		
		try {      // for error handling
			appFuncType();
			astFactory.addASTChild(currentAST, returnAST);
			{
			switch ( LA(1)) {
			case INTLIT:
			{
				AST tmp9_AST = null;
				tmp9_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp9_AST);
				match(INTLIT);
				break;
			}
			case IDENT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp10_AST = null;
			tmp10_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp10_AST);
			match(IDENT);
			appFuncParameters();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp11_AST = null;
			tmp11_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp11_AST);
			match(COLON);
			typeSpec();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp12_AST = null;
			tmp12_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp12_AST);
			match(SEMI);
			appFuncDecl_AST = (AST)currentAST.root;
		}
		catch (RecognitionException e) {
			
				parseFail = true;
				reportError("line " + e.getLine() + ":" + e.getColumn() +
					", " + e.getMessage());
			
		}
		returnAST = appFuncDecl_AST;
	}
	
	public final void varType() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST varType_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_var:
			{
				AST tmp13_AST = null;
				tmp13_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp13_AST);
				match(LITERAL_var);
				varType_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_appvar:
			{
				AST tmp14_AST = null;
				tmp14_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp14_AST);
				match(LITERAL_appvar);
				varType_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException e) {
			
				reportError("missing attribute type, line " + e.getLine() + ":" +
					e.getColumn() + ", " + e.getMessage());
			
		}
		returnAST = varType_AST;
	}
	
	public final void typeSpec() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST typeSpec_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_const:
			{
				typeAttr();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case IDENT:
			case LITERAL_char:
			case LITERAL_int:
			case LITERAL_long:
			case LITERAL_short:
			case LITERAL_float:
			case LITERAL_double:
			case LITERAL_struct:
			case LITERAL_union:
			case LITERAL_unsigned:
			case LITERAL_signed:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			typeName();
			astFactory.addASTChild(currentAST, returnAST);
			{
			switch ( LA(1)) {
			case TIMES:
			{
				AST tmp15_AST = null;
				tmp15_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp15_AST);
				match(TIMES);
				break;
			}
			case SEMI:
			case COMMA:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			typeSpec_AST = (AST)currentAST.root;
		}
		catch (RecognitionException e) {
			
				reportError("invalid type, line " + e.getLine() + ":" +
					e.getColumn() + ", " + e.getMessage());
			
		}
		returnAST = typeSpec_AST;
	}
	
	public final void funcType() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST funcType_AST = null;
		
		try {      // for error handling
			AST tmp16_AST = null;
			tmp16_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp16_AST);
			match(LITERAL_func);
			funcType_AST = (AST)currentAST.root;
		}
		catch (RecognitionException e) {
			
				reportError("missing attribute type, line " + e.getLine() + ":" +
					e.getColumn() + ", " + e.getMessage());
			
		}
		returnAST = funcType_AST;
	}
	
	public final void funcParameters() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST funcParameters_AST = null;
		
		try {      // for error handling
			AST tmp17_AST = null;
			tmp17_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp17_AST);
			match(LPAREN);
			funcReqParam();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop762:
			do {
				if ((LA(1)==COMMA)) {
					AST tmp18_AST = null;
					tmp18_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp18_AST);
					match(COMMA);
					typeSpec();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop762;
				}
				
			} while (true);
			}
			AST tmp19_AST = null;
			tmp19_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp19_AST);
			match(RPAREN);
			funcParameters_AST = (AST)currentAST.root;
		}
		catch (RecognitionException e) {
			
				reportError("line " + e.getLine() + ":" + e.getColumn() +
					", " + e.getMessage());
			
		}
		returnAST = funcParameters_AST;
	}
	
	public final void appFuncType() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST appFuncType_AST = null;
		
		try {      // for error handling
			AST tmp20_AST = null;
			tmp20_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp20_AST);
			match(LITERAL_appfunc);
			appFuncType_AST = (AST)currentAST.root;
		}
		catch (RecognitionException e) {
			
				reportError("missing attribute type, line " + e.getLine() + ":" +
					e.getColumn() + ", " + e.getMessage());
			
		}
		returnAST = appFuncType_AST;
	}
	
	public final void appFuncParameters() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST appFuncParameters_AST = null;
		
		try {      // for error handling
			AST tmp21_AST = null;
			tmp21_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp21_AST);
			match(LPAREN);
			appFuncReqParam();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop765:
			do {
				if ((LA(1)==COMMA)) {
					AST tmp22_AST = null;
					tmp22_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp22_AST);
					match(COMMA);
					typeSpec();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop765;
				}
				
			} while (true);
			}
			AST tmp23_AST = null;
			tmp23_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp23_AST);
			match(RPAREN);
			appFuncParameters_AST = (AST)currentAST.root;
		}
		catch (RecognitionException e) {
			
				reportError("line " + e.getLine() + ":" + e.getColumn() +
					", " + e.getMessage());
			
		}
		returnAST = appFuncParameters_AST;
	}
	
	public final void funcReqParam() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST funcReqParam_AST = null;
		
		try {      // for error handling
			AST tmp24_AST = null;
			tmp24_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp24_AST);
			match(LITERAL_pFrame);
			funcReqParam_AST = (AST)currentAST.root;
		}
		catch (RecognitionException e) {
			
				reportError("missing required parameter, line " + e.getLine() + ":" +
					e.getColumn() + ", " + e.getMessage());
			
		}
		returnAST = funcReqParam_AST;
	}
	
	public final void appFuncReqParam() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST appFuncReqParam_AST = null;
		
		try {      // for error handling
			AST tmp25_AST = null;
			tmp25_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp25_AST);
			match(LITERAL_AppID);
			appFuncReqParam_AST = (AST)currentAST.root;
		}
		catch (RecognitionException e) {
			
				reportError("missing required parameter, line " + e.getLine() + ":" +
					e.getColumn() + ", " + e.getMessage());
			
		}
		returnAST = appFuncReqParam_AST;
	}
	
	public final void typeAttr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST typeAttr_AST = null;
		
		try {      // for error handling
			AST tmp26_AST = null;
			tmp26_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp26_AST);
			match(LITERAL_const);
			typeAttr_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = typeAttr_AST;
	}
	
	public final void typeName() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST typeName_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case IDENT:
			case LITERAL_struct:
			case LITERAL_union:
			{
				{
				{
				switch ( LA(1)) {
				case LITERAL_struct:
				case LITERAL_union:
				{
					dataType();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case IDENT:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				AST tmp27_AST = null;
				tmp27_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp27_AST);
				match(IDENT);
				}
				typeName_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_char:
			case LITERAL_int:
			case LITERAL_long:
			case LITERAL_short:
			case LITERAL_unsigned:
			case LITERAL_signed:
			{
				{
				{
				switch ( LA(1)) {
				case LITERAL_unsigned:
				case LITERAL_signed:
				{
					typeMod();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case LITERAL_char:
				case LITERAL_int:
				case LITERAL_long:
				case LITERAL_short:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				numericType();
				astFactory.addASTChild(currentAST, returnAST);
				}
				typeName_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_float:
			case LITERAL_double:
			{
				decimalType();
				astFactory.addASTChild(currentAST, returnAST);
				typeName_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_3);
		}
		returnAST = typeName_AST;
	}
	
	public final void dataType() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST dataType_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_struct:
			{
				AST tmp28_AST = null;
				tmp28_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp28_AST);
				match(LITERAL_struct);
				dataType_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_union:
			{
				AST tmp29_AST = null;
				tmp29_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp29_AST);
				match(LITERAL_union);
				dataType_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_4);
		}
		returnAST = dataType_AST;
	}
	
	public final void typeMod() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST typeMod_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_unsigned:
			{
				AST tmp30_AST = null;
				tmp30_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp30_AST);
				match(LITERAL_unsigned);
				typeMod_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_signed:
			{
				AST tmp31_AST = null;
				tmp31_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp31_AST);
				match(LITERAL_signed);
				typeMod_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_5);
		}
		returnAST = typeMod_AST;
	}
	
	public final void numericType() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST numericType_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_char:
			{
				AST tmp32_AST = null;
				tmp32_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp32_AST);
				match(LITERAL_char);
				numericType_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_int:
			{
				AST tmp33_AST = null;
				tmp33_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp33_AST);
				match(LITERAL_int);
				numericType_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_long:
			{
				AST tmp34_AST = null;
				tmp34_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp34_AST);
				match(LITERAL_long);
				numericType_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_short:
			{
				AST tmp35_AST = null;
				tmp35_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp35_AST);
				match(LITERAL_short);
				numericType_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_3);
		}
		returnAST = numericType_AST;
	}
	
	public final void decimalType() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST decimalType_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_float:
			{
				AST tmp36_AST = null;
				tmp36_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp36_AST);
				match(LITERAL_float);
				decimalType_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_double:
			{
				AST tmp37_AST = null;
				tmp37_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp37_AST);
				match(LITERAL_double);
				decimalType_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_3);
		}
		returnAST = decimalType_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"INTLIT",
		"IDENT",
		":",
		";",
		"\"var\"",
		"\"appvar\"",
		"\"func\"",
		"\"appfunc\"",
		"(",
		",",
		")",
		"\"pFrame\"",
		"\"AppID\"",
		"*",
		"\"char\"",
		"\"int\"",
		"\"long\"",
		"\"short\"",
		"\"float\"",
		"\"double\"",
		"\"struct\"",
		"\"union\"",
		"\"const\"",
		"\"unsigned\"",
		"\"signed\"",
		"WS",
		"COMMENT",
		"LBRAKET",
		"RBRAKET"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap=null;
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 3842L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 469499936L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 155776L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 32L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 3932160L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	
	}
